#include <libopencm3/stm32/gpio.h>

#include <led.h>
#include <macros.h>

struct led leds[] = {
	{ GPIOC, GPIO10, 1 },
};

size_t nleds = count_of(leds);

void led_enable(struct led *led)
{
	if (!led)
		return;

	if (led->invert)
		gpio_clear(led->port, led->pin);
	else
		gpio_set(led->port, led->pin);
}

void led_disable(struct led *led)
{
	if (!led)
		return;

	if (led->invert)
		gpio_set(led->port, led->pin);
	else
		gpio_clear(led->port, led->pin);
}
